From bce2aa0acec36a45b9aa576424fca54ca47c825e Mon Sep 17 00:00:00 2001
From: derekriemer <derek.riemer@colorado.edu>
Date: Fri, 9 Jan 2015 08:54:24 -0700
Subject: [PATCH] In firefox, when the status of a download changes, nvda no
 longer speaks everything about the download.

---
 source/appModules/firefox.py | 13 +++++++++++++
 1 file changed, 13 insertions(+)

diff --git a/source/appModules/firefox.py b/source/appModules/firefox.py
index 4ebd097..2ee8e3b 100755
--- a/source/appModules/firefox.py
+++ b/source/appModules/firefox.py
@@ -4,6 +4,7 @@
 #This file is covered by the GNU General Public License.
 #See the file COPYING for more details.
 
+import re
 import appModuleHandler
 import controlTypes
 import api
@@ -11,6 +12,7 @@ import speech
 import winUser
 
 class AppModule(appModuleHandler.AppModule):
+	downloadCashe = ""
 
 	def event_stateChange(self, obj, nextHandler):
 		if obj.role == controlTypes.ROLE_DOCUMENT and controlTypes.STATE_BUSY in obj.states and winUser.isWindowVisible(obj.windowHandle) and obj.isInForeground:
@@ -23,4 +25,15 @@ class AppModule(appModuleHandler.AppModule):
 				return
 		nextHandler()
 
+	def event_nameChange(self, obj, nextHandler):
+		if obj.role == controlTypes.ROLE_LISTITEM and obj.windowText == u'Library':
+			#the mozilla download manager packs everything into the name field of the download, so parse it for two numbers and  a % sign, go back to the previous space, and then cashe it.
+			RE_PERCENTAGE = r'\s\d{1,3}\%' #matches a space followed by a percentage value between 0 and 100.
+			splitName=re.split(RE_PERCENTAGE, obj.name)
+			if splitName == self.downloadCashe:
+				nextHandler()
+			else:
+				self.downloadCashe = splitName
+
+
 	event_gainFocus = event_stateChange
-- 
1.9.5.msysgit.0

